#include "ParticionaNumero.h"


void ParticionaNumero(ConjuntoNumeros l, int numParticao, int opcao, int tam){

    srand(time(NULL));
    
    if(tam < numParticao){
        cout << "Não é possível particionar conjunto menor que o número de partições." << endl;
        return;
    }

    cout << endl << "-------------------------------------------------" << endl;
    
    if(opcao >= 3 ){
        cout << "Funcao Objetivo Inicial: " << l.AvaliaFuncaoObjetivo() << endl;
    }
    
    Timer t;
    
    switch (opcao){
        /*Contrucao Gulosa*/
        case 1:
            t.start();
            l.ConstroiSolucaoGulosa();
            t.stop();
            cout << "Lista após Contrução Gulosa" << endl;
            break;
        /*Contrucao Gulosa*/
        case 2:
            t.start();
            l.ConstroiSolucaoAleatoria();
            t.stop();
            cout << endl << "Lista após Contrução Aleatória." << endl;
            break;
        /*Best Improvment*/
        case 3:
            t.start();
            l.BestImprovement();
            t.stop();
            cout << endl << "Lista após Best Improvement" << endl;
            break;
        /*First Improvment*/
        case 4:
            t.start();
            l.FirstImprovement();
            t.stop();
            cout << endl << "Lista após First Improvement" << endl;
            break;

        case 5:
            t.start();
            l.RandomImprovement();
            t.stop();
            cout << endl << "Lista após Randon Improvement" << endl;
            break;

        case 6:
            t.start();
            l.MultiStart();
            t.stop();
            cout << endl << "Lista após MultiStart" << endl;
            break;
            
        case 7:
            t.start();
            l.BuscaTabu();
            t.stop();
            cout << endl << "Lista após Busca Tabu" << endl;
            break;
        case 8:
            t.start();
            l.Grasp();
            t.stop();
            cout << endl << "Lista após Grasp" << endl;
            break;
        case 9:
            t.start();
            l.SimulatedAnnealing();
            t.stop();
            cout << endl << "Lista após Simulated Anneling" << endl;
            break;
        default:
            cout << endl << "Opção inválida!" << endl;
            break;
    }


    if(opcao <= 9 ){
        l.ImprimeParticionamento();
        l.ImprimeSoma();
        cout << "Tempo: "; t.printElapsedTimeInMilliSec();
    }


}