#ifndef CONJUNTONUMEROS_H
#define	CONJUNTONUMEROS_H

#include <stddef.h>
#include <stdlib.h>
#include <iostream>
//#include "/home/marcelo/NetBeansProjects/Biblioteca/QuickSort.h"
#include "/home/marcelo/NetBeansProjects/Biblioteca/Lista.h"
//#include "/home/marcelo/NetBeansProjects/Biblioteca/MergeSort.h"

class ConjuntoNumeros : public Lista{
    private:
        int *saving, *soma;
        int numParticao;
    public:
        ConjuntoNumeros(int tam);
        void SetNumParticao(int numParticao);
        int GetNumParticao();
        void SetValorSaving(int indice, int valor);
        int GetValorSaving(int indice);
        void ImprimeIndice();
        void ImprimeSaving();
        void MovimentoSubstituicao(int i, int particao);
        void MovimentoTroca(int i, int j);
        int AvaliaFuncaoObjetivo();
        void ConstroiSolucaoGulosa();
        void ConstroiSolucaoAleatoria();
        int GetMenorSoma();
        void ImprimeParticionamento();
        void AtualizaSoma();
        void ImprimeSoma();
        void MelhorVizinhoTrocaMelhora(int &melhorTrocaI, int &melhorTrocaJ, int &melhorTrocaFO);
        void MelhorVizinhoSubstMelhora(int &melhorSubstI, int &melhorSubstP, int &melhorSubstFO);
        void MelhorVizinhoTroca(int &melhorTrocaI, int &melhorTrocaJ, int &foMelhorTroca);
        void MelhorVizinhoSubst(int &melhorSubstI, int &melhorSubstP, int &foMelhorSubst);
        void PrimeiroMelhorVizinhoTroca(int &melhorTrocaI, int &melhorTrocaJ, int &melhorTrocaFO);
        void PrimeiroMelhorVizinhoSubst(int &melhorSubstI, int &melhorSubstP, int &melhorSubstFO);
        void BestImprovement();
        void FirstImprovement();
        void RandomImprovement();
        void MultiStart();
        void BuscaTabu();
        void Grasp();
        void ConstrucaoGrasp(int alpha);
        int GetParticaoListaRestrita(int alpha);
        int GetIndiceListaRestrita(int alpha, int *listaRestrita, int n);
        void SimulatedAnnealing();
        double TemperaturaInicialSA();
};

void EmbaralhaVetor(int *vetAleatorio, int tam);
void CopiaVetor(int *origem, int *destino, int tam);
void MensagemMelhoraFO(int iteracao, int melhorFo);
void MensagemFOInicial(int melhorFo);
double Randomico(int inicial, int final);

#endif	/* CONJUNTONUMEROS_H */

